INTERFACE [arm && pic_gic && pf_fvp_base]:

#include "gic.h"
#include "initcalls.h"

// ------------------------------------------------------------------------
IMPLEMENTATION [arm && pic_gic && pf_fvp_base]:

#include "boot_alloc.h"
#include "irq_mgr_msi.h"
#include "gic_v3.h"
#include "kmem.h"

PUBLIC static FIASCO_INIT
void
Pic::init()
{
  auto *g =
    new Boot_object<Gic_v3>(Kmem::mmio_remap(Mem_layout::Gic_dist_phys_base,
                                             Gic_dist::Size),
                            Kmem::mmio_remap(Mem_layout::Gic_redist_phys_base,
                                             Mem_layout::Gic_redist_size));

  g->add_its(Kmem::mmio_remap(Mem_layout::Gic_its_phys_base,
                              Mem_layout::Gic_its_size));

  gic = g;

  typedef Irq_mgr_msi<Gic_v3, Gic_msi> Mgr;
  Irq_mgr::mgr = new Boot_object<Mgr>(g, g->msi_chip());
}

// ------------------------------------------------------------------------
IMPLEMENTATION [arm && pic_gic && mp && pf_fvp_base]:

PUBLIC static
void Pic::init_ap(Cpu_number cpu, bool resume)
{
  gic->init_ap(cpu, resume);
}
